{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{# App Macros #}

{% macro help_toolstip(text) %}
    <span class="pull-right">
        <span class="fa fa-question-circle-o text-muted _tooltip"
              data-tooltip='{"side": "bottom"}'
              title="{{ text | trans }}">
        </span>
    </span>
{% endmacro %}

{% macro download_type(type) %}
    {% if type == 'manual' %}
        {% set download = {
            label: 'label.download_type_manual' | trans,
            description: 'help.download_type_manual' | trans,
            icon: 'fa-hand-o-up',
        } %}
    {% elseif type == 'webservice' %}
        {% set download = {
            label: 'label.download_type_webservice' | trans,
            description: 'help.download_type_webservice' | trans,
            icon: 'fa-globe',
        } %}
    {% endif %}
    <span class="_tooltip" data-tooltip='{"side": "bottom"}' title="{{ download.description }}">
        <span class="fa {{ download.icon }}"></span> {{ download.label }}
    </span>
{% endmacro %}

{% macro flux_status_frame(flux) %}
    {% set process = flux.lastProcess('complete') %}
    {% if process is not null %}
        {% if flux.scheduleHour is null %}
            <span class="label label-default">
                <i class="fa fa-fw fa-pause"></i> {{ "label.status.deactivated" | trans }}
            </span>
        {% else %}
            {% set status = process.status %}
            {% if status == 'ok' %}
                <span class="label label-success">
                    <i class="fa fa-fw fa-check"></i> {{ get_static(process, "statusDefinitions")['ok'][0] | trans }}
                </span>
            {% elseif status == 'wait' %}
                <span class="label label-info">
                    <i class="fa fa-fw fa-clock-o"></i> {{ get_static(process, "statusDefinitions")['wait'][0] | trans }}
                </span>
            {% elseif status == 'running' %}
                <span class="label label-info">
                    <i class="fa fa-fw fa-refresh fa-spin"></i> {{ get_static(process, "statusDefinitions")['running'][0] | trans }}
                </span>
            {% elseif status == 'error' %}
                <span class="label label-danger"{% if is_granted('ROLE_ADMIN') %} title="{{ process.logs|join("\n") }}"{% endif %}>
                    <i class="fa fa-exclamation-circle fa-fw"></i> {{ get_static(process, "statusDefinitions")['error'][0] | trans }}
                </span>
            {% endif %}
        {% endif %}
    {% endif %}
{% endmacro %}

{# conversions #}
{% macro bytesToSize(bytes) %}
    {% spaceless %}
        {% set kilobyte = 1024 %}
        {% set megabyte = kilobyte * 1024 %}
        {% set gigabyte = megabyte * 1024 %}
        {% set terabyte = gigabyte * 1024 %}

        {% if bytes < kilobyte %}
            {{ bytes ~ 'o' }}
        {% elseif bytes < megabyte %}
            {{ (bytes / kilobyte)|round|number_format(0, '.') ~ 'ko' }}
        {% elseif bytes < gigabyte %}
            {{ (bytes / megabyte)|number_format(2, '.') ~ 'Mo' }}
        {% elseif bytes < terabyte %}
            {{ (bytes / gigabyte)|number_format(2, '.') ~ 'Go' }}
        {% else %}
            {{ (bytes / terabyte)|number_format(2, '.') ~ 'To' }}
        {% endif %}
    {% endspaceless %}
{% endmacro %}

{% macro partialDownloadBtn(flux) %}
    {% if flux.query %}
        {% set process = flux.getLastProcess('partial') %}

        {% if process and process.running %}
            <a class="btn btn-primary pull-right" disabled="disabled" title="{{ 'text.partial_feed_running' | trans }}" data-tooltip='{"side": "left"}'>
                <span class="fa fa-clock-o"></span> {{ 'btn.partial_feed_running' | trans }}
            </a>
        {% elseif process and process.checksum == flux.checksum %}
            <a data-toggle="modal-remote"
               href="{{ path('flux.download.partial', {"id": flux.id}) }}"
               class="btn btn-primary pull-right">
                <span class="fa fa-download"></span> {{ 'btn.partial_feed_download' | trans }}
            </a>
        {% else %}
            <a data-toggle="modal-remote"
               href="{{ path('flux.download.partial', {"id": flux.id }) }}"
               class="btn btn-primary pull-right">
                <span class="fa fa-cogs"></span> {{ 'btn.partial_feed_generate' | trans }}
            </a>
        {% endif %}
    {% else %}
        <a class="btn btn-primary pull-right" disabled="disabled" title="{{ "msg.feed_query_required" | trans }}" data-tooltip='{"side": "left"}'>
            <span class="fa fa-download"></span> {{ 'btn.partial_feed_download' | trans }}
        </a>
    {% endif %}
{% endmacro %}


{% macro completeDownloadBtn(flux) %}
    {% set is_empty = not flux.query %}
    {% set is_schedule = flux.scheduleHour is not null %}
    {% set is_authorized = is_granted('flux.download', flux) %}
    {% set last_success_process = flux.getLastSuccessProcess('complete') %}
    {% set is_available = last_success_process is not null %}
    {% if app.user == flux.user %}

    {# LABEL #}
    {# ROUTE #}
    {%- if is_schedule %}
        {% set label %}<span class="fa fa-download"></span> {{ "btn.complete_feed_download" | trans }}{% endset %}
        {% set href = path('flux.download.complete', {id: flux.id}) %}
    {% else %}
        {% set label %}<span class="fa fa-cogs"></span> {{ "btn.complete_feed_schedule" | trans }}{% endset %}
        {% set href = path('flux.download.schedule', {id: flux.id}) %}
    {% endif -%}

    {# TITLE #}
    {% set title %}
        {%- if is_empty %}
            {{ "msg.feed_query_required" | trans }}
        {% elseif not is_authorized %}
            {{ "msg.feed_authorized_required" | trans }}
        {% elseif not is_available and is_schedule %}
            {{ "msg.feed_available_required" | trans }}
        {% endif -%}
    {% endset %}

    {# DISABLED #}
    {% set disabled = not is_authorized or is_empty or (not is_available and is_schedule) %}

    {# HREF #}
    {% set href = not disabled ? href : false %}

    <a class="btn btn-primary pull-right" {% if href %}href="{{ href }}" data-toggle="modal-remote"{% endif %} {% if title %}data-tooltip title="{{ title }}"{% endif %} {% if disabled %}disabled="disabled"{% endif %}>
        {{ label }}
    </a>
    {% endif %}
{% endmacro %}